#!/usr/local/bin/perl
##############################################################################
# Copyright: Binny V Abraham 2002                                            #
# If you want to use this script, Leave this message here                    #
##############################################################################
# Website: http://binnyva.tripod.com                                         #
# E-Mail : binnyva@rediffmail.com                                            #
##############################################################################
# Name Of Script : Traffic Analyzer                                          #
# Version        : 1.00.A                                                    #
# This script is made to work with the Hit Logger script.                    #
# This script will not work without it. So please enable it in your site     #
# A file called with the form is also needed. Other wise all options will    #
# be shown.                                                                  #
# This script will give you a graphical break down of your visitors. It      #
# compare the hits in Morning and Evening, in the different hours of the     #
# day, and in all the months. It will display the results in a very detailed #
# and attractive graphical form.                                             #
# Just execute the file to get the results.                                  #
##############################################################################
#Needed Files                                                                #
# log.pl - The Hit Logger Script. This logs all the hits.                    #
# trafficanalizer.pl - This file. This analizes the log book and reports back#
# log.html - Log Book. All the hits are logged there.                        #
# ref.txt - Stores the current visitor number. Gets updated every hit.       #
##############################################################################
# use strict;

# Set Variables
my $logfile = "log.html";   # Log File(Must be the same as given in the logger)
my $bar_height = 15;        # Height of the bars
my $times = 10;             # This number will be multiplied with every variable (For Bar width)
# End Variables

# Open Log File, Take Contents
open (LOG, "$logfile") || die "Error : Can't open $logfile: $!\n";;
my @LINES=<LOG>;
close(LOG);
my $size=@LINES;

my $show_morning_evening=1;	# Display 'Morning/Evening Traffic Analyser'
my $show_hourly=1;			# Display 'Hourly Traffic Analyser'
my $show_monthly=1;			# Display 'Monthly Traffic Analyser'
my $show_log_book=0;   		# Display 'Show Log Book'

# Initialization of Varibles
my $am = 0;
my $pm = 0;
my @am_hours = (0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
my @pm_hours = (0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
#Months
my @months   = (0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);

# Analyse the contents of the Log File
for (my $i=0; $i<=$size; $i++)
 {
 $_=$LINES[$i];
 if(/ AM/) # Find wether time is AM or PM and the Hour 
  {
  $am++;
  if(/center>0:/){$am_hours[0]++;}
  elsif(/center>1:/){$am_hours[1]++;}
  elsif(/center>2:/){$am_hours[2]++;}
  elsif(/center>3:/){$am_hours[3]++;}
  elsif(/center>4:/){$am_hours[4]++;}
  elsif(/center>5:/){$am_hours[5]++;}
  elsif(/center>6:/){$am_hours[6]++;}
  elsif(/center>7:/){$am_hours[7]++;}
  elsif(/center>8:/){$am_hours[8]++;}
  elsif(/center>9:/){$am_hours[9]++;}
  elsif(/center>10:/){$am_hours[10]++;}
  elsif(/center>11:/){$am_hours[11]++;}
  elsif(/center>12:/){$am_hours[12]++;}
  }
 elsif(/ PM/) 
  {
  $pm++; 
  if(/center>1:/){$pm_hours[1]++;}
  elsif(/center>2:/){$pm_hours[2]++;}
  elsif(/center>3:/){$pm_hours[3]++;}
  elsif(/center>4:/){$pm_hours[4]++;}
  elsif(/center>5:/){$pm_hours[5]++;}
  elsif(/center>6:/){$pm_hours[6]++;}
  elsif(/center>7:/){$pm_hours[7]++;}
  elsif(/center>8:/){$pm_hours[8]++;}
  elsif(/center>9:/){$pm_hours[9]++;}
  elsif(/center>10:/){$pm_hours[10]++;}
  elsif(/center>11:/){$pm_hours[11]++;}
  elsif(/center>12:/){$pm_hours[12]++;}  
  }
 if(/January/) {$months[0]++;} # Find Month
 elsif(/February/) {$months[1]++;}
 elsif(/March/) {$months[2]++;}
 elsif(/April/) {$months[3]++;}
 elsif(/May/) {$months[4]++;}
 elsif(/June/) {$months[5]++;}
 elsif(/July/) {$months[6]++;}
 elsif(/August/) {$months[7]++;}
 elsif(/September/) {$months[8]++;}
 elsif(/October/) {$months[9]++;}
 elsif(/November/) {$months[10]++;}
 elsif(/December/) {$months[11]++;}
 }

# Get the Value x $times (For the Bar width)
my @am_bar_width = (0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
my @pm_bar_width = (0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
my @months_bar_width = (0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
for (my $i=0; $i<13; $i++) {
	$am_bar_width[$i] = $am_hours[$i] * $times;
	$pm_bar_width[$i] = $pm_hours[$i] * $times;
	$months_bar_width[$i] = $months[$i] * $times;
}

# Find the percentage of the AM and PM  
my $totap = $am + $pm;
my $amp=int($am * 100/$totap);
my $pmp=int($pm * 100/$totap);
 
# Print out the results
print "Content-Type: text/html\n\n";
print "<html>\n<head>\n<title>Traffic Analysis Report</title>\n</head>\n";
print "<STYLE>\nA{COLOR:blue;TEXT-DECORATION: none;}\nA:hover{Font-Weight: bold;COLOR:red;}\n</STYLE>\n<body>\n";
print "<h1 align=center>Traffic Analysis Report</h1>\n";
if($show_morning_evening) # Morning/Evening Traffic Analyzer
 {
 print "<h3>Comparison of Visits in Morning or Evening</h3>\n";
 print "<br>Visits in Morning :$amp %<br>Visits in Evening :$pmp %<br>\n";
 $am=$am*2;
 $pm=$pm*2;
 print "<center><table cellspacing=0 cellpadding=0 width=200 height=$bar_height>\n";
 print "<tr><td bgcolor=red width=\"$amp%\"><center><font face=tahoma size=1>AM</font></center></td><td bgcolor=green width=\"$pmp%\"><center><font face=tahoma size=1>PM</font></center></td></tr>\n";
 print "</table></center>\n\n<br><hr>\n\n";
 }
if($show_hourly) # Hourly Traffic Analyzer 
 {
 print "<h3>Hourly Taffic Analysis Report</h3>\n";
 print "<table>\n";
 print "<tr><td>Morning</td></tr>\n";
 print "<tr><td>0 AM</td><td><table><tr><td height=$bar_height width=$am_bar_width[0] bgcolor=\#000000></td></tr></table></td><td>$am_hours[0]</td></tr>\n";
 print "<tr><td>1 AM</td><td><table><tr><td height=$bar_height width=$am_bar_width[1] bgcolor=\#ff0000></td></tr></table></td><td>$am_hours[1]</td></tr>\n";
 print "<tr><td>2 AM</td><td><table><tr><td height=$bar_height width=$am_bar_width[2] bgcolor=\#00ff00></td></tr></table></td><td>$am_hours[2]</td></tr>\n";
 print "<tr><td>3 AM</td><td><table><tr><td height=$bar_height width=$am_bar_width[3] bgcolor=\#0000ff></td></tr></table></td><td>$am_hours[3]</td></tr>\n";
 print "<tr><td>4 AM</td><td><table><tr><td height=$bar_height width=$am_bar_width[4] bgcolor=\#fe1efe></td></tr></table></td><td>$am_hours[4]</td></tr>\n";
 print "<tr><td>5 AM</td><td><table><tr><td height=$bar_height width=$am_bar_width[5] bgcolor=\#11ffff></td></tr></table></td><td>$am_hours[5]</td></tr>\n";
 print "<tr><td>6 AM</td><td><table><tr><td height=$bar_height width=$am_bar_width[6] bgcolor=\#41ff11></td></tr></table></td><td>$am_hours[6]</td></tr>\n";
 print "<tr><td>7 AM</td><td><table><tr><td height=$bar_height width=$am_bar_width[7] bgcolor=\#f498b4></td></tr></table></td><td>$am_hours[7]</td></tr>\n";
 print "<tr><td>8 AM</td><td><table><tr><td height=$bar_height width=$am_bar_width[8] bgcolor=\#8b01d7></td></tr></table></td><td>$am_hours[8]</td></tr>\n";
 print "<tr><td>9 AM</td><td><table><tr><td height=$bar_height width=$am_bar_width[9] bgcolor=\#d2f4d7></td></tr></table></td><td>$am_hours[9]</td></tr>\n";
 print "<tr><td>10 AM</td><td><table><tr><td height=$bar_height width=$am_bar_width[10] bgcolor=\#988506></td></tr></table></td><td>$am_hours[10]</td></tr>\n";
 print "<tr><td>11 AM</td><td><table><tr><td height=$bar_height width=$am_bar_width[11] bgcolor=\#0c0c0c></td></tr></table></td><td>$am_hours[11]</td></tr>\n";
 print "<tr><td>12 AM</td><td><table><tr><td height=$bar_height width=$am_bar_width[12] bgcolor=\#f3a5bd></td></tr></table></td><td>$am_hours[12]</td></tr>\n";
 print "<tr><td><br></td></tr>\n";
 print "<tr><td>Afternoon</td></tr>\n";
 print "<tr><td>0 PM</td><td><table><tr><td height=$bar_height width=$pm_bar_width[0] bgcolor=\#000000></td></tr></table></td><td>$pm_hours[0]</td></tr>\n";
 print "<tr><td>1 PM</td><td><table><tr><td height=$bar_height width=$pm_bar_width[1] bgcolor=\#ff0000></td></tr></table></td><td>$pm_hours[1]</td></tr>\n";
 print "<tr><td>2 PM</td><td><table><tr><td height=$bar_height width=$pm_bar_width[2] bgcolor=\#00ff00></td></tr></table></td><td>$pm_hours[2]</td></tr>\n"; 
 print "<tr><td>3 PM</td><td><table><tr><td height=$bar_height width=$pm_bar_width[3] bgcolor=\#0000ff></td></tr></table></td><td>$pm_hours[3]</td></tr>\n";
 print "<tr><td>4 PM</td><td><table><tr><td height=$bar_height width=$pm_bar_width[4] bgcolor=\#fe1efe></td></tr></table></td><td>$pm_hours[4]</td></tr>\n";
 print "<tr><td>5 PM</td><td><table><tr><td height=$bar_height width=$pm_bar_width[5] bgcolor=\#11ffff></td></tr></table></td><td>$pm_hours[5]</td></tr>\n";
 print "<tr><td>6 PM</td><td><table><tr><td height=$bar_height width=$pm_bar_width[6] bgcolor=\#41ff11></td></tr></table></td><td>$pm_hours[6]</td></tr>\n";
 print "<tr><td>7 PM</td><td><table><tr><td height=$bar_height width=$pm_bar_width[7] bgcolor=\#f498b4></td></tr></table></td><td>$pm_hours[7]</td></tr>\n";
 print "<tr><td>8 PM</td><td><table><tr><td height=$bar_height width=$pm_bar_width[8] bgcolor=\#8b01d7></td></tr></table></td><td>$pm_hours[8]</td></tr>\n";
 print "<tr><td>9 PM</td><td><table><tr><td height=$bar_height width=$pm_bar_width[9] bgcolor=\#d2f4d7></td></tr></table></td><td>$pm_hours[9]</td></tr>\n";
 print "<tr><td>10 PM</td><td><table><tr><td height=$bar_height width=$pm_bar_width[10] bgcolor=\#988506></td></tr></table></td><td>$pm_hours[10]</td></tr>\n";
 print "<tr><td>11 PM</td><td><table><tr><td height=$bar_height width=$pm_bar_width[11] bgcolor=\#0c0c0c></td></tr></table></td><td>$pm_hours[11]</td></tr>\n";
 print "<tr><td>12 PM</td><td><table><tr><td height=$bar_height width=$pm_bar_width[12] bgcolor=\#f3a5bd></td></tr></table></td><td>$pm_hours[12]</td></tr>\n";
 print "</table>\n";
 print "\n<br><hr>\n";
 }
if ($show_monthly) # Monthly Traffic Analyzer       
 {
 print "<h3>Monthly Taffic Analysis Report</h3>\n";
 print "<table>\n";
 print "<tr><td>January</td>  <td><table><tr><td height=$bar_height width=$months_bar_width[0] bgcolor=\#000000></td></tr></table></td><td>$months[0]</td></tr>\n";
 print "<tr><td>February</td> <td><table><tr><td height=$bar_height width=$months_bar_width[1] bgcolor=\#ff0000></td></tr></table></td><td>$months[1]</td></tr>\n";
 print "<tr><td>March</td>    <td><table><tr><td height=$bar_height width=$months_bar_width[2] bgcolor=\#00ff00></td></tr></table></td><td>$months[2]</td></tr>\n";
 print "<tr><td>April</td>    <td><table><tr><td height=$bar_height width=$months_bar_width[3] bgcolor=\#0000ff></td></tr></table></td><td>$months[3]</td></tr>\n";
 print "<tr><td>May</td>      <td><table><tr><td height=$bar_height width=$months_bar_width[4] bgcolor=\#fe1efe></td></tr></table></td><td>$months[4]</td></tr>\n";
 print "<tr><td>June</td>     <td><table><tr><td height=$bar_height width=$months_bar_width[5] bgcolor=\#11ffff></td></tr></table></td><td>$months[5]</td></tr>\n";
 print "<tr><td>July</td>     <td><table><tr><td height=$bar_height width=$months_bar_width[6] bgcolor=\#41ff11></td></tr></table></td><td>$months[6]</td></tr>\n";
 print "<tr><td>August</td>   <td><table><tr><td height=$bar_height width=$months_bar_width[7] bgcolor=\#d2f4d7></td></tr></table></td><td>$months[7]</td></tr>\n";
 print "<tr><td>September</td><td><table><tr><td height=$bar_height width=$months_bar_width[8] bgcolor=\#988506></td></tr></table></td><td>$months[8]</td></tr>\n";
 print "<tr><td>October</td>  <td><table><tr><td height=$bar_height width=$months_bar_width[9] bgcolor=\#f498b4></td></tr></table></td><td>$months[9]</td></tr>\n";
 print "<tr><td>November</td> <td><table><tr><td height=$bar_height width=$months_bar_width[10] bgcolor=\#8b01d7></td></tr></table></td><td>$months[10]</td></tr>\n";
 print "<tr><td>December</td> <td><table><tr><td height=$bar_height width=$months_bar_width[11] bgcolor=\#0c0c0c></td></tr></table></td><td>$months[11]</td></tr>\n";
 print "</table>\n<br><hr>\n";
 }
# If No options are chosen
if(	$show_morning_evening==0 &&
	$show_hourly==0 &&
	$show_monthly==0 && 
	$show_log_book==0) {
		print "<br><br><br>\n<center><b><i>You have not chosen any option.</i></b><br>\nPlease go Back and chose any option.</center>";
}

# Show Log Book 
if ($show_log_book) { print "\n<script language=Javascript>\nlocation.href=\"log.html\"\n</script>\n"; }
else { print "<br><br>\n<a href=log.html>Click here for Log Book</a>\n"; } # Show Link to Log Book

print "\n</body>\n</html>";
